import {
  createPersistentPort
} from "./chunk-OZGBKVJJ.js";
import {
  usePostMessaging
} from "./chunk-FLKFPNRC.js";
import {
  createEndpointRuntime,
  createStreamWirings
} from "./chunk-3SJGMQZN.js";
import "./chunk-KEPAOTUH.js";

// src/content-script.ts
var win = usePostMessaging("content-script");
var port = createPersistentPort();
var endpointRuntime = createEndpointRuntime(
  "content-script",
  (message) => {
    if (message.destination.context === "window")
      win.postMessage(message);
    else
      port.postMessage(message);
  }
);
win.onMessage((message) => {
  message.origin = {
    context: "window",
    tabId: null
  };
  endpointRuntime.handleMessage(message);
});
port.onMessage(endpointRuntime.handleMessage);
function allowWindowMessaging(nsps) {
  win.setNamespace(nsps);
  win.enable();
}
var { sendMessage, onMessage } = endpointRuntime;
var { openStream, onOpenStreamChannel } = createStreamWirings(endpointRuntime);
export {
  allowWindowMessaging,
  onMessage,
  onOpenStreamChannel,
  openStream,
  sendMessage
};
